////////////////////////////////////////////////////////////////////////////////
// chaos_exception.cpp : exception

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_exception : exception class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_exception::chaos_exception() :
	std::exception(),
	cause(generic)
{
}

// normal constructor

chaos_exception::chaos_exception(cause_type new_cause) :
	std::exception(),
	cause(new_cause)
{
}

// copy constructor

chaos_exception::chaos_exception(const chaos_exception& org) :
	std::exception(org),
	cause(org.cause)
{
}

// destructor

chaos_exception::~chaos_exception() throw () {
}

////////////////////////////////////////////////////////////////////////////////
// get & set

// get message

const char* chaos_exception::get_message(cause_type cause) {
	const char* message;
	switch (cause) {
	case generic:
		message = "generic error";
		break;
	case bad_format:
		message = "bad format";
		break;
	case few_memory:
		message = "few memory";
		break;
	case zero_divide:
		message = "divided by zero";
		break;
	case stack_overflow:
		message = "stack overflow";
		break;
	case io_error:
		message = "i/o error";
		break;
	case gui_error:
		message = "gui error";
		break;
	default:
		message = "unknown error";
		break;
	}
	return message;
}

////////////////////////////////////////////////////////////////////////////////
// operator

// copy

chaos_exception& chaos_exception::operator=(
	const chaos_exception& org)
{
	cause = org.cause;
	return *this;
}

////////////////////////////////////////////////////////////////////////////////
// implementation

// what

const char* chaos_exception::what() const throw () {
	return get_message(cause);
}
