////////////////////////////////////////////////////////////////////////////////
// chaos_exception.h : exception

#ifndef CHAOS_EXCEPTION_H_INCLUDED
#define CHAOS_EXCEPTION_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// declare

class chaos_exception;

////////////////////////////////////////////////////////////////////////////////
// chaos_exception : exception class

class chaos_exception :
	public std::exception
{
// enum
public:
	// cause
	enum cause_type {
		unknown,
		generic,
		bad_format,
		few_memory,
		zero_divide,
		stack_overflow,
		io_error,
		gui_error
	};

// attribute
private:
	// cause
	cause_type cause;

// create & destroy
public:
	// default constructor
	chaos_exception();
	// normal constructor
	chaos_exception(cause_type new_cause);
	// copy constructor
	chaos_exception(const chaos_exception& org);
	// destructor
	virtual ~chaos_exception() throw ();

// get & set
private:
	// get message
	static const char* get_message(cause_type cause);

public:
	// get cause
	cause_type get_cause() const {
		return cause;
	}

// operator
public:
	// copy
	chaos_exception& operator=(
		const chaos_exception& org);

// implementation
public:
	// what
	virtual const char* what() const throw ();
};

#endif // CHAOS_EXCEPTION_H_INCLUDED
