////////////////////////////////////////////////////////////////////////////////
// chaos_func.h : function

#ifndef CHAOS_FUNC_H_INCLUDED
#define CHAOS_FUNC_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// declare

class chaos_func;

////////////////////////////////////////////////////////////////////////////////
// include

#ifndef CHAOS_STRING_H_INCLUDED
#include "chaos_string.h"
#endif // CHAOS_STRING_H_INCLUDED

#ifndef CHAOS_VALUE_H_INCLUDED
#include "chaos_value.h"
#endif // CHAOS_VALUE_H_INCLUDED

#ifndef CHAOS_SYSTEM_H_INCLUDED
#include "chaos_system.h"
#endif // CHAOS_SYSTEM_H_INCLUDED

#ifndef CHAOS_INTERPRETER_H_INCLUDED
#include "chaos_interpreter.h"
#endif // CHAOS_INTERPRETER_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// chaos_func : function base class

class chaos_func {
// typedef
public:
	// function params type
	typedef std::list<chaos_value> params_type;

// create & destroy
public:
	// default constructor
	chaos_func();
	// destructor
	virtual ~chaos_func();

// function
public:
	// get name
	virtual chaos_string get_name() const = 0;
	// execute
	virtual chaos_value execute(
		chaos_system* system,
		chaos_interpreter* interpreter,
		params_type* params) const = 0;
};

#endif // CHAOS_FUNC_H_INCLUDED
