////////////////////////////////////////////////////////////////////////////////
// chaos_func_clr.cpp : clr function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_clr.h"
#include "chaos_image_realizer.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_clr : clr function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_clr::chaos_func_clr() :
	chaos_func()
{
}

// destructor

chaos_func_clr::~chaos_func_clr() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_clr::get_name() const {
	return "clr";
}

// execute

chaos_value chaos_func_clr::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #Clr(image)
	// params:
	//   image : image number(integer)
	// example:
	//   #Clr(1);
	if (params->size() < 1) {
		LOG_ERR(
			"error : func clr::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	chaos_func::params_type::iterator it = params->begin();
	int image = (int)(*it).get_integer();
	chaos_string info =
		chaos_image_realizer::encode_clr_info();
	system->set_image_info(image, info);
	return chaos_value();
}
