////////////////////////////////////////////////////////////////////////////////
// chaos_func_fillclr.cpp : fill clear function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_fillclr.h"
#include "chaos_image_realizer.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_fillclr : fill clear function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_fillclr::chaos_func_fillclr() :
	chaos_func()
{
}

// destructor

chaos_func_fillclr::~chaos_func_fillclr() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_fillclr::get_name() const {
	return "fillclr";
}

// execute

chaos_value chaos_func_fillclr::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #FillClr(image, color)
	// params:
	//   image : image number(integer)
	//   color : clear color(color)
	// example:
	//   #FillClr(1, RGB(0, 0, 0));
	if (params->size() < 2) {
		LOG_ERR(
			"error : func fillclr::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	chaos_func::params_type::iterator it = params->begin();
	int image = (int)(*(it++)).get_integer();
	chaos_color color = (*it).get_color();
	chaos_string info =
		chaos_image_realizer::encode_fill_clr_info(
			color);
	system->set_image_info(image, info);
	return chaos_value();
}
