////////////////////////////////////////////////////////////////////////////////
// chaos_func_loadtextf.cpp : load message file function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_loadtextf.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_loadtextf : load message file function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_loadtextf::chaos_func_loadtextf() :
	chaos_func()
{
}

// destructor

chaos_func_loadtextf::~chaos_func_loadtextf() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_loadtextf::get_name() const {
	return "loadtextf";
}

// execute

chaos_value chaos_func_loadtextf::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #LoadTextf(filename)
	// params:
	//   filename : message filename(string)
	// example:
	//   #LoadTextf("./1day/txt/1.txt");
	if (params->size() < 1) {
		LOG_ERR(
			"error : func loadtextf::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	chaos_func::params_type::iterator it = params->begin();
	chaos_string filename = (*it).get_string();
	system->load_cur_messages(filename);
	return chaos_value();
}
