////////////////////////////////////////////////////////////////////////////////
// chaos_func_manager.h : function manager

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_manager.h"
#include "chaos_func_alphablt.h"
#include "chaos_func_blt.h"
#include "chaos_func_breakapp.h"
#include "chaos_func_cddaready.h"
#include "chaos_func_clr.h"
#include "chaos_func_clrsavetmp.h"
#include "chaos_func_clrsavetmpex.h"
#include "chaos_func_createimage.h"
#include "chaos_func_createtextf.h"
#include "chaos_func_end.h"
#include "chaos_func_fillclr.h"
#include "chaos_func_gosub.h"
#include "chaos_func_goto.h"
#include "chaos_func_if.h"
#include "chaos_func_inputbox2.h"
#include "chaos_func_loadimage.h"
#include "chaos_func_loadtextf.h"
#include "chaos_func_locatef.h"
#include "chaos_func_messagebox.h"
#include "chaos_func_monofill.h"
#include "chaos_func_mouseclickeventex.h"
#include "chaos_func_mouseclickwait.h"
#include "chaos_func_openplaymcicdda.h"
#include "chaos_func_paint.h"
#include "chaos_func_painttextbuffer.h"
#include "chaos_func_playwave.h"
#include "chaos_func_printtextf.h"
#include "chaos_func_resumeload.h"
#include "chaos_func_resumesave.h"
#include "chaos_func_return.h"
#include "chaos_func_selectcolor.h"
#include "chaos_func_selectex.h"
#include "chaos_func_setdefaultcolor.h"
#include "chaos_func_setmessagelength.h"
#include "chaos_func_setrectwaiticon.h"
#include "chaos_func_settextprintf.h"
#include "chaos_func_settextspeedf.h"
#include "chaos_func_settexttype.h"
#include "chaos_func_settextwaitpos.h"
#include "chaos_func_startload.h"
#include "chaos_func_stopload.h"
#include "chaos_func_stopmcicdda.h"
#include "chaos_func_stopmciwave.h"
#include "chaos_func_stopsave.h"
#include "chaos_func_systemload.h"
#include "chaos_func_systemsave.h"
#include "chaos_func_textbuffer.h"
#include "chaos_func_transfade.h"
#include "chaos_func_transfill.h"
#include "chaos_func_wai.h"
#include "chaos_func_wait.h"
#include "chaos_func_wipe.h"
#include "chaos_utility.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_manager : function manager class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_manager::chaos_func_manager() {
	add_func(new chaos_func_alphablt);
	add_func(new chaos_func_blt);
	add_func(new chaos_func_breakapp);
	add_func(new chaos_func_cddaready);
	add_func(new chaos_func_clr);
	add_func(new chaos_func_clrsavetmp);
	add_func(new chaos_func_clrsavetmpex);
	add_func(new chaos_func_createimage);
	add_func(new chaos_func_createtextf);
	add_func(new chaos_func_end);
	add_func(new chaos_func_fillclr);
	add_func(new chaos_func_gosub);
	add_func(new chaos_func_goto);
	add_func(new chaos_func_if);
	add_func(new chaos_func_inputbox2);
	add_func(new chaos_func_loadimage);
	add_func(new chaos_func_loadtextf);
	add_func(new chaos_func_locatef);
	add_func(new chaos_func_messagebox);
	add_func(new chaos_func_monofill);
	add_func(new chaos_func_mouseclickeventex);
	add_func(new chaos_func_mouseclickwait);
	add_func(new chaos_func_openplaymcicdda);
	add_func(new chaos_func_paint);
	add_func(new chaos_func_painttextbuffer);
	add_func(new chaos_func_playwave);
	add_func(new chaos_func_printtextf);
	add_func(new chaos_func_resumeload);
	add_func(new chaos_func_resumesave);
	add_func(new chaos_func_return);
	add_func(new chaos_func_selectcolor);
	add_func(new chaos_func_selectex);
	add_func(new chaos_func_setdefaultcolor);
	add_func(new chaos_func_setmessagelength);
	add_func(new chaos_func_setrectwaiticon);
	add_func(new chaos_func_settextprintf);
	add_func(new chaos_func_settextspeedf);
	add_func(new chaos_func_settexttype);
	add_func(new chaos_func_settextwaitpos);
	add_func(new chaos_func_startload);
	add_func(new chaos_func_stopload);
	add_func(new chaos_func_stopmcicdda);
	add_func(new chaos_func_stopmciwave);
	add_func(new chaos_func_stopsave);
	add_func(new chaos_func_systemload);
	add_func(new chaos_func_systemsave);
	add_func(new chaos_func_textbuffer);
	add_func(new chaos_func_transfade);
	add_func(new chaos_func_transfill);
	add_func(new chaos_func_wai);
	add_func(new chaos_func_wait);
	add_func(new chaos_func_wipe);
}

// destructor

chaos_func_manager::~chaos_func_manager() {
	for (
		func_map_type::iterator it = func_map.begin();
		it != func_map.end();
		it++)
	{
		delete (*it).second;
	}
}

// get singleton instance

chaos_func_manager* chaos_func_manager::instance() {
	static chaos_func_manager funcs;
	return &funcs;
}

////////////////////////////////////////////////////////////////////////////////
// function

// add function

void chaos_func_manager::add_func(chaos_func* func) {
	func_map.insert(
		func_map_type::value_type(func->get_name(), func));
}

// find function

const chaos_func* chaos_func_manager::find(
	const chaos_string& func_name) const
{
	chaos_string func_pure_name;
	if (*(func_name.c_str()) == '#') {
		func_pure_name = func_name.substr(1);
	} else {
		func_pure_name = func_name;
	}
	func_pure_name = chaos_utility::to_lower_str(func_pure_name);
	func_map_type::const_iterator it = func_map.find(func_pure_name);
	const chaos_func* func = NULL;
	if (it != func_map.end()) {
		func = (*it).second;
	}
	return func;
}
