////////////////////////////////////////////////////////////////////////////////
// chaos_func_manager.h : function manager

#ifndef CHAOS_FUNC_MANAGER_H_INCLUDED
#define CHAOS_FUNC_MANAGER_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// declare

class chaos_func_manager;

////////////////////////////////////////////////////////////////////////////////
// include

#ifndef CHAOS_FUNC_H_INCLUDED
#include "chaos_func.h"
#endif // CHAOS_FUNC_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// chaos_func_manager : function manager class

class chaos_func_manager {
// typedef
private:
	// function map type
	typedef std::map<chaos_string, chaos_func*> func_map_type;

// attribute
private:
	// function map
	func_map_type func_map;

// create & destroy
public:
	// default constructor
	chaos_func_manager();
	// destructor
	~chaos_func_manager();

	// get singleton instance
	static chaos_func_manager* instance();

// function
private:
	// add function
	void add_func(chaos_func* func);

public:
	// find function
	const chaos_func* find(const chaos_string& func_name) const;
};

#endif // CHAOS_FUNC_MANAGER_H_INCLUDED
