////////////////////////////////////////////////////////////////////////////////
// chaos_func_mouseclickwait.cpp : mouse click wait function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_mouseclickwait.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_mouseclickwait : mouse click wait function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_mouseclickwait::chaos_func_mouseclickwait() :
	chaos_func()
{
}

// destructor

chaos_func_mouseclickwait::~chaos_func_mouseclickwait() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_mouseclickwait::get_name() const {
	return "mouseclickwait";
}

// execute

chaos_value chaos_func_mouseclickwait::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #MouseClickWait(button)
	// params
	//   button : wait click button(integer)
	// example:
	//   #MouseClickWait(LEFT);
	if (params->size() < 1) {
		LOG_ERR(
			"error : mouseclickwait::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	system->change_skip_mode(chaos_system::skip_none);
	system->change_system_mode(chaos_system::sysmode_userclick);
	return chaos_value();
}
