////////////////////////////////////////////////////////////////////////////////
// chaos_func_openplaymcicdda.cpp : play cdda audio function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_openplaymcicdda.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_openplaymcicdda : play cdda audio function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_openplaymcicdda::chaos_func_openplaymcicdda() :
	chaos_func()
{
}

// destructor

chaos_func_openplaymcicdda::~chaos_func_openplaymcicdda() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_openplaymcicdda::get_name() const {
	return "openplaymcicdda";
}

// execute

chaos_value chaos_func_openplaymcicdda::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #OpenPlayMCICdda(track1, track2, repeat)
	// params:
	//   track1 : play start track(integer)
	//   track2 : play end track(integer)
	//   repeat : repeat play(integer)
	// example :
	//   #OpenPlayMCICdda(16, 17, 1);
	if (params->size() < 3) {
		LOG_ERR(
			"error : func openplaymcicdda::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	chaos_func::params_type::iterator it = params->begin();
	int track1 = (int)(*(it++)).get_integer();
	int track2 = (int)(*(it++)).get_integer();
	int repeat = (int)(*it).get_integer();
	chaos_string info =
		chaos_system::encode_cd_audio_info(
			track1, track2,
			repeat);
	system->play_cd_audio(info);
	return chaos_value();
}
