////////////////////////////////////////////////////////////////////////////////
// chaos_func_paint.cpp : paint function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_paint.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_paint : paint function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_paint::chaos_func_paint() :
	chaos_func()
{
}

// destructor

chaos_func_paint::~chaos_func_paint() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_paint::get_name() const {
	return "paint";
}

// execute

chaos_value chaos_func_paint::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* /*params*/) const
{
	// format:
	//   #Paint()
	// example:
	//   #Paint();
	chaos_string info = system->get_image_info(1);
	bool dirty_image = true, dirty_message = false;
	if (system->get_skip_mode() != chaos_system::skip_none) {
		switch (system->get_skip_speed()) {
		case chaos_system::sspeed_fast:
			dirty_message = true;
			break;
		case chaos_system::sspeed_jump:
			dirty_image = false;
			break;
		}
	}
	system->set_image_info(0, info);
	if (dirty_image) {
		system->set_dirty_image(true);
	}
	if (dirty_message) {
		system->set_dirty_message(true);
	}
	return chaos_value();
}
