////////////////////////////////////////////////////////////////////////////////
// chaos_func_selectcolor.cpp : selection color function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_selectcolor.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_selectcolor : selection color function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_selectcolor::chaos_func_selectcolor() :
	chaos_func()
{
}

// destructor

chaos_func_selectcolor::~chaos_func_selectcolor() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_selectcolor::get_name() const {
	return "selectcolor";
}

// execute

chaos_value chaos_func_selectcolor::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #SelectColor(color)
	// params:
	//   color : selection color(color)
	// example:
	//   #SelectColor(RGB(128, 10, 10));
	if (params->size() < 1) {
		LOG_ERR(
			"error : func selectcolor::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	chaos_func::params_type::iterator it = params->begin();
	chaos_color color = (*it).get_color();
	system->set_selection_default_color(color);
	return chaos_value();
}
