////////////////////////////////////////////////////////////////////////////////
// chaos_func_selectex.cpp : select branch function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_selectex.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_selectex : select branch function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_selectex::chaos_func_selectex() :
	chaos_func()
{
}

// destructor

chaos_func_selectex::~chaos_func_selectex() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_selectex::get_name() const {
	return "selectex";
}

// execute

chaos_value chaos_func_selectex::execute(
	chaos_system* system,
	chaos_interpreter* interpreter,
	params_type* /*params*/) const
{
	// format:
	//   #SelectEx()
	//   {
	//     [statement1 [statement2 [...]]]
	//   }
	// example:
	//   #SelectEx()
	//   {
	//     #PrintTextf(1, 474, "_Start", "./1day/scr2ex2.txt");
	//     #PrintTextf(1, 475, "_Kana", "./1day/scr2.txt");
	//   }
	chaos_token token = interpreter->get_token();
	switch (token.get_type()) {
	case chaos_token::tkn_braceleft:
		system->start_selection_preparation();
		break;
	default:
		LOG_ERR(
			"error : func selectex::execute - "
			"bad token(%s)\n",
			token.get_literal().c_str());
		throw chaos_exception(chaos_exception::bad_format);
	}
	return chaos_value();
}
