////////////////////////////////////////////////////////////////////////////////
// chaos_func_setmessagelength.cpp : set message length function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_setmessagelength.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_setmessagelength : set message length function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_setmessagelength::chaos_func_setmessagelength() :
	chaos_func()
{
}

// destructor

chaos_func_setmessagelength::~chaos_func_setmessagelength() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_setmessagelength::get_name() const {
	return "setmessagelength";
}

// execute

chaos_value chaos_func_setmessagelength::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #SetMessageLength(frame, length)
	// params:
	//   frame  : frame number(integer)
	//   length : message length(integer)
	// example:
	//   #SetMessageLength(1, 23);
	if (params->size() < 2) {
		LOG_ERR(
			"error : func setmessagelength::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	params_type::iterator it = params->begin();
	int frame = (*(it++)).get_integer();
	int length = (*it).get_integer();
	int x, y;
	int old_length;
	chaos_color color;
	chaos_string info = system->get_message_info(frame);
	chaos_system::decode_message_info(
		info,
		x, y,
		old_length,
		color);
	info = chaos_system::encode_message_info(
		x, y,
		length,
		color);
	system->set_message_info(frame, info);
	return chaos_value();
}
