////////////////////////////////////////////////////////////////////////////////
// chaos_func_settextspeedf.cpp : set message wait time function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_settextspeedf.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_settextspeedf : set message wait time function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_settextspeedf::chaos_func_settextspeedf() :
	chaos_func()
{
}

// destructor

chaos_func_settextspeedf::~chaos_func_settextspeedf() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_settextspeedf::get_name() const {
	return "settextspeedf";
}

// execute

chaos_value chaos_func_settextspeedf::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #SetTextSpeedf(frame, time)
	// params:
	//   frame : frame number(integer)
	//   time  : wait time(integer)
	// example:
	//   #SetTextSpeedf(1, 30);
	if (params->size() < 2) {
		LOG_ERR(
			"error : func settextspeedf::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	params_type::iterator it = params->begin();
	int frame = (*(it++)).get_integer();
	int speed = (*it).get_integer();
	system->set_message_speed(frame, speed);
	return chaos_value();
}
