////////////////////////////////////////////////////////////////////////////////
// chaos_func_settexttype.cpp : set message text shape function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_settexttype.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_settexttype : set message text shape function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_settexttype::chaos_func_settexttype() :
	chaos_func()
{
}

// destructor

chaos_func_settexttype::~chaos_func_settexttype() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_settexttype::get_name() const {
	return "settexttype";
}

// execute

chaos_value chaos_func_settexttype::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #SetTextType(mshape)
	//   #SetTextType()
	// params:
	//   mshape : shape of message text(integer)
	// example:
	//   #SetTextType(3);
	//   #SetTextType();
	int mshape = 0;
	if (params->size() >= 1) {
		chaos_func::params_type::iterator it = params->begin();
		mshape = (*it).get_integer();
	}
	system->set_message_shape(mshape);
	return chaos_value();
}
