////////////////////////////////////////////////////////////////////////////////
// chaos_func_settextwaitpos.cpp : set prompt pos function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_settextwaitpos.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_settextwaitpos : set prompt pos function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_settextwaitpos::chaos_func_settextwaitpos() :
	chaos_func()
{
}

// destructor

chaos_func_settextwaitpos::~chaos_func_settextwaitpos() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_settextwaitpos::get_name() const {
	return "settextwaitpos";
}

// execute

chaos_value chaos_func_settextwaitpos::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #SetTextWaitPos(show, x, y)
	//   #SetTextWaitPos()
	// params:
	//   show : place prompt position(boolean)
	//   x    : prompt x position(integer)
	//   y    : prompt y position(integer)
	// example:
	//   #SetTextWaitPos(TRUE, 720, 530);
	//   #SetTextWaitPos();
	if (params->size() >= 3) {
		chaos_func::params_type::iterator it = params->begin();
		bool place = (*(it++)).get_boolean();
		int x = (int)(*(it++)).get_integer();
		int y = (int)(*it).get_integer();
		chaos_string info = chaos_system::encode_prompt_info(
			place,
			x, y);
		system->set_prompt_info(info);
	} else {
		system->clear_prompt_info();
	}
	return chaos_value();
}
