////////////////////////////////////////////////////////////////////////////////
// chaos_func_textbuffer.cpp : message text clear mode function

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_textbuffer.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_textbuffer : message text clear mode function class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_textbuffer::chaos_func_textbuffer() :
	chaos_func()
{
}

// destructor

chaos_func_textbuffer::~chaos_func_textbuffer() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_textbuffer::get_name() const {
	return "textbuffer";
}

// execute

chaos_value chaos_func_textbuffer::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #TextBuffer(mode)
	// params:
	//   mode : message text clear mode(integer)
	// example:
	//   #TextBuffer(1);
	if (params->size() < 1) {
		LOG_ERR(
			"error : func textbuffer::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	chaos_func::params_type::iterator it = params->begin();
	int clear_mode = (int)(*it).get_integer();
	system->set_message_clear_mode(clear_mode);
	system->clear_message();
	return chaos_value();
}
