////////////////////////////////////////////////////////////////////////////////
// chaos_func_wai.cpp : wait function(spell miss?)

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_func_wai.h"
#include "chaos_exception.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_func_wai : wait function class(spell miss?)

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_func_wai::chaos_func_wai() :
	chaos_func()
{
}

// destructor

chaos_func_wai::~chaos_func_wai() {
}

////////////////////////////////////////////////////////////////////////////////
// function

// get name

chaos_string chaos_func_wai::get_name() const {
	return "wai";
}

// execute

chaos_value chaos_func_wai::execute(
	chaos_system* system,
	chaos_interpreter* /*interpreter*/,
	params_type* params) const
{
	// format:
	//   #Wai(time)
	// params:	
	//   time : wait time(integer)
	// example:
	//   #Wai(1500);
	if (params->size() < 1) {
		LOG_ERR(
			"error : func wai::execute - "
			"too few params\n");
		throw chaos_exception(chaos_exception::bad_format);
	}
	chaos_func::params_type::iterator it = params->begin();
	int time = (int)(*it).get_integer();
	if (system->get_skip_mode() != chaos_system::skip_none) {
		switch (system->get_skip_speed()) {
		case chaos_system::sspeed_fast:
		case chaos_system::sspeed_jump:
			time = 0;
			break;
		}
	}
	if (time > 0) {
		system->change_system_mode(chaos_system::sysmode_wait);
		system->set_wait_time(time);
	}
	return chaos_value();
}
