////////////////////////////////////////////////////////////////////////////////
// chaos_image_loader.h : image loader

#ifndef CHAOS_IMAGE_LOADER_H_INCLUDED
#define CHAOS_IMAGE_LOADER_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// declare

class chaos_image_loader;

////////////////////////////////////////////////////////////////////////////////
// include

#ifndef CHAOS_FILE_DATA_H_INCLUDED
#include "chaos_file_data.h"
#endif // CHAOS_FILE_DATA_H_INCLUDED

#ifndef CHAOS_IMAGE_H_INCLUDED
#include "chaos_image.h"
#endif // CHAOS_IMAGE_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// chaos_image_loader : image loader class

class chaos_image_loader {
// attribute
private:
	// file data
	chaos_file_data* filedata;

protected:
	// image
	chaos_image* image;

// create & destroy
public:
	// constructor
	chaos_image_loader(
		chaos_file_data* org_filedata,
		chaos_image* org_image);
	// destructor
	virtual ~chaos_image_loader();

// declaration
public:
	// load image
	virtual bool load() = 0;

// operation
public:
	// read from file
	bool read_file(void* buffer, size_t size);
};

#endif // CHAOS_IMAGE_LOADER_H_INCLUDED
