////////////////////////////////////////////////////////////////////////////////
// chaos_message_box.cpp : message box

////////////////////////////////////////////////////////////////////////////////
// include

#include "stdafx.h"

#include "chaos_message_box.h"
#include "chaos_resource.h"
#include "chaos_utility.h"

////////////////////////////////////////////////////////////////////////////////
// chaos_message_box : message box class

////////////////////////////////////////////////////////////////////////////////
// create & destroy

// default constructor

chaos_message_box::chaos_message_box() :
	chaos_dlg()
{
}

// destructor

chaos_message_box::~chaos_message_box() {
}

// get singleton instance

chaos_message_box* chaos_message_box::instance() {
	static chaos_message_box message_box;
	return &message_box;
}

////////////////////////////////////////////////////////////////////////////////
// operation

// modal

bool chaos_message_box::do_modal() {
	bool result;

#ifdef CHAOS_GUI_WIN32

	result = (MessageBox(
		NULL,
		message.c_str(),
		chaos_resource::instance()->get_resource_text(
			chaos_resource::app_name).c_str(),
		MB_OK) == IDOK);

#elif defined(CHAOS_GUI_GTK)

	widgets.clear();
	dialog = gtk_dialog_new();
	gtk_widget_ref(dialog);
	build_widgets(
		GTK_DIALOG(dialog)->action_area,
		chaos_resource::instance()->get_resource_text(
			chaos_resource::dlg_std_action_area));
	build_widgets(
		GTK_DIALOG(dialog)->vbox,
		chaos_resource::instance()->get_resource_text(
			chaos_resource::dlg_message_box));
	init_dialog_default(
		chaos_resource::instance()->get_resource_text(
			chaos_resource::app_name));
	GtkWidget* cancel_button = get_widget("cancel");
	if (cancel_button != NULL) {
		gtk_widget_hide(cancel_button);
	}
	GtkWidget* message_label = get_widget("message");
	if (message_label != NULL) {
		gtk_label_set_text(
			GTK_LABEL(message_label),
			chaos_utility::sjis_to_gui(
				message).c_str());
	}
	gtk_widget_show(dialog);
	gtk_grab_add(dialog);
	push_current_modaling(dialog);
	gtk_main();
	pop_current_modaling();
	result = dialog_result;
	destroy_widgets();
	gtk_grab_remove(dialog);
	gtk_widget_unref(dialog);
	dialog = NULL;

#endif // CHAOS_GUI

	return result;
}

// show message

bool chaos_message_box::show_message(const chaos_string& message) {
	instance()->set_message(message);
	return instance()->do_modal();
}
