////////////////////////////////////////////////////////////////////////////////
// chaos_message_box.h : message box

#ifndef CHAOS_MESSAGE_BOX_H_INCLUDED
#define CHAOS_MESSAGE_BOX_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// declare

class chaos_message_box;

////////////////////////////////////////////////////////////////////////////////
// include

#ifndef CHAOS_STRING_H_INCLUDED
#include "chaos_string.h"
#endif // CHAOS_STRING_H_INCLUDED

#ifndef CHAOS_DLG_H_INCLUDED
#include "chaos_dlg.h"
#endif // CHAOS_DLG_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// chaos_message_box : message box class

class chaos_message_box :
	public chaos_dlg
{
// attribute
private:
	// message
	chaos_string message;

// create & destroy
private:
	// default constructor
	chaos_message_box();

public:
	// destructor
	~chaos_message_box();

	// get singleton instance
	static chaos_message_box* instance();

// get & set
public:
	// get message
	const chaos_string& get_message() {
		return message;
	}
	// set message
	void set_message(const chaos_string& new_message) {
		message = new_message;
	}

// operation
public:
	// modal
	bool do_modal();
	// show message
	static bool show_message(const chaos_string& message);
};

#endif // CHAOS_MESSAGE_BOX_H_INCLUDED
