////////////////////////////////////////////////////////////////////////////////
// chaos_message_manager.h : message manager

#ifndef CHAOS_MESSAGE_MANAGER_H_INCLUDED
#define CHAOS_MESSAGE_MANAGER_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// declare

class chaos_message_manager;

////////////////////////////////////////////////////////////////////////////////
// include

#ifndef CHAOS_STRING_H_INCLUDED
#include "chaos_string.h"
#endif // CHAOS_STRING_H_INCLUDED

#ifndef CHAOS_FILE_DATA_H_INCLUDED
#include "chaos_file_data.h"
#endif // CHAOS_FILE_DATA_H_INCLUDED

////////////////////////////////////////////////////////////////////////////////
// message manager class

class chaos_message_manager {
// typedef
private:
	// message map type
	typedef std::map<int, chaos_string> message_map;

// attribute
private:
	// filename
	chaos_string filename;
	// message map
	message_map messages;
	// max id
	int max_id;

// create & destroy
public:
	// default constructor
	chaos_message_manager();
	// destructor
	~chaos_message_manager();
	// clear
	void clear();
	// load
	bool load(chaos_file_data* filedata);

// get & set
public:
	// get filename
	chaos_string get_filename() const {
		return filename;
	}
	// set filename
	void set_filename(const chaos_string& new_filename) {
		filename = new_filename;
	}
	// get message
	chaos_string get_message(int id) const;
	// get max id
	int get_max_id() const {
		return max_id;
	}
};

#endif // CHAOS_MESSAGE_MANAGER_H_INCLUDED
